"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Items = void 0;
const exceptions_1 = require("./exceptions");
class Items {
    constructor(Options) {
        this.Options = Options;
        this.DefaultCurrency = "USD";
        this.Output = {
            items: [],
            description: this.Options.description,
            currency: this.Options.currency || this.DefaultCurrency,
            total: 0,
        };
        this.get = () => this.Output;
        this.getOptions = () => this.Options;
        // Validate Currency
        if (typeof this.Options.currency === "string" &&
            this.Options.currency.length > 3)
            throw new exceptions_1.GatewayException(`Invalid or currency has not been provided!`);
        else {
            // Resolve Items
            this.Output.items = this.Options.items.map((item, index) => {
                var _a;
                return ({
                    sku: item.sku || Date.now() + index,
                    currency: ((_a = this.Options.currency) === null || _a === void 0 ? void 0 : _a.toUpperCase()) || this.DefaultCurrency,
                    name: item.name,
                    description: item.description,
                    price: parseFloat(item.price.toFixed(2)),
                    quantity: item.quantity || 0 > 0 ? item.quantity : 1,
                });
            });
            // Create Total Amount
            this.Output.total = parseFloat(this.Output.items
                .reduce((p, c) => p + c.price * c.quantity, 0)
                .toFixed(2));
        }
    }
}
exports.Items = Items;
