import { Environment, EpicGateway, Methods } from "../gateway";
import Paypal from "paypal-rest-sdk";
import { Items } from "../items";
export interface CheckoutConfiguration {
    methods?: "paypal"[];
    returnUrl: string;
    cancelUrl: string;
}
export interface ExecuteOptions {
    paymentId: string;
    payerId?: string;
}
export interface CreateIntentResponse {
    method: Methods;
    environment: Environment;
    key: string;
    response: Paypal.PaymentResponse;
}
export interface ExecuteIntentResponse {
    method: Methods;
    environment: Environment;
    response: Paypal.PaymentResponse;
}
declare const _default: (Parent: EpicGateway<"Paypal">) => {
    new (): {
        Configuration?: CheckoutConfiguration | undefined;
        Instance: typeof Paypal;
        create: (Items: Items, custom?: {
            readonly id?: string | undefined;
            intent?: string | undefined;
            payer?: {
                payment_method: string;
            } | undefined;
            transactions?: Paypal.Transaction[] | undefined;
            readonly state?: string | undefined;
            experience_profile_id?: string | undefined;
            note_to_payer?: string | undefined;
            redirect_urls?: {
                return_url?: string | undefined;
                cancel_url?: string | undefined;
            } | undefined;
            readonly failure_reason?: string | undefined;
            readonly create_time?: string | undefined;
            readonly update_time?: string | undefined;
            readonly links?: Paypal.Link[] | undefined;
        } | undefined) => Promise<CreateIntentResponse>;
        execute: (options: ExecuteOptions) => Promise<ExecuteIntentResponse>;
        configure: (configuration: CheckoutConfiguration) => any;
    };
};
export default _default;
