"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const exceptions_1 = require("../exceptions");
exports.default = (Parent) => class {
    constructor() {
        this.Instance = Parent.createInstance();
        this.create = (Items, custom) => new Promise((resolve, reject) => {
            var _a, _b, _c, _d, _e;
            // Get Items Output
            const Output = Items.get();
            // Create Payment Intent
            this.Instance.payment.create(Object.assign({ intent: "sale", payer: {
                    payment_method: ((_c = (_b = (_a = this.Configuration) === null || _a === void 0 ? void 0 : _a.methods) === null || _b === void 0 ? void 0 : _b[0]) === null || _c === void 0 ? void 0 : _c.toLowerCase()) || "paypal",
                }, redirect_urls: {
                    return_url: (_d = this.Configuration) === null || _d === void 0 ? void 0 : _d.returnUrl,
                    cancel_url: (_e = this.Configuration) === null || _e === void 0 ? void 0 : _e.cancelUrl,
                }, transactions: [
                    {
                        item_list: {
                            items: Output.items.map((item) => (Object.assign(Object.assign({}, item), { price: item.price.toString() }))),
                        },
                        amount: {
                            currency: Output.currency.toUpperCase(),
                            total: Output.total.toString(),
                        },
                        description: Output.description,
                    },
                ] }, custom), function (error, response) {
                var _a, _b, _c, _d;
                if (error)
                    reject(new exceptions_1.GatewayException(error));
                else
                    resolve({
                        method: Parent.getMethod(),
                        environment: ((_a = Parent.getConfiguration()) === null || _a === void 0 ? void 0 : _a.environment) || "Sandbox",
                        key: (_d = (_b = Parent.getConfiguration()) === null || _b === void 0 ? void 0 : _b.credentials[((_c = Parent.getConfiguration()) === null || _c === void 0 ? void 0 : _c.environment) || "Sandbox"]) === null || _d === void 0 ? void 0 : _d.PK,
                        response,
                    });
            });
        });
        this.execute = (options) => new Promise((resolve, reject) => {
            if (!options.payerId)
                reject(new exceptions_1.GatewayException(`A valid Payer ID is required!`));
            else
                this.Instance.payment.execute(options.paymentId, { payer_id: options.payerId }, (error, response) => {
                    var _a;
                    if (error || response.state !== "approved")
                        reject(new exceptions_1.GatewayException(error || `Payment Approval has been failed!`));
                    else
                        resolve({
                            method: Parent.getMethod(),
                            environment: ((_a = Parent.getConfiguration()) === null || _a === void 0 ? void 0 : _a.environment) || "Sandbox",
                            response,
                        });
                });
        });
        this.configure = (configuration) => {
            // Validate Configuration
            if (!configuration.returnUrl ||
                typeof configuration.returnUrl !== "string")
                throw new exceptions_1.GatewayException(`Please provide a valid Return URL!`);
            if (!configuration.cancelUrl ||
                typeof configuration.cancelUrl !== "string")
                throw new exceptions_1.GatewayException(`Please provide a valid Cancel URL!`);
            // Save Configuration
            this.Configuration = configuration;
            return this;
        };
    }
};
