import { Environment, EpicGateway, Methods } from "../gateway";
import { Stripe } from "stripe";
import { Items } from "../items";
export interface CheckoutConfiguration {
    methods?: Stripe.Checkout.SessionCreateParams.PaymentMethodType[];
    returnUrl: string;
    cancelUrl: string;
}
export interface ExecuteOptions {
    paymentId: string;
    payerId?: string;
}
export interface ExecuteIntentResponse {
    method: Methods;
    environment: Environment;
    response: {
        session: Stripe.Response<Stripe.Checkout.Session>;
        paymentIntent: Stripe.Response<Stripe.PaymentIntent>;
    };
}
export interface CreateIntentResponse {
    method: Methods;
    environment: Environment;
    key: string;
    response: Stripe.Response<Stripe.Checkout.Session>;
}
declare const _default: (Parent: EpicGateway<"Stripe">) => {
    new (): {
        Instance: Stripe;
        Options?: PaymentOptions | undefined;
        Configuration?: CheckoutConfiguration | undefined;
        create: (Items: Items, custom?: {
            cancel_url?: string | undefined;
            payment_method_types?: Stripe.Checkout.SessionCreateParams.PaymentMethodType[] | undefined;
            success_url?: string | undefined;
            allow_promotion_codes?: boolean | undefined;
            billing_address_collection?: "auto" | "required" | undefined;
            client_reference_id?: string | undefined;
            customer?: string | undefined;
            customer_email?: string | undefined;
            discounts?: Stripe.Checkout.SessionCreateParams.Discount[] | undefined;
            expand?: string[] | undefined;
            line_items?: Stripe.Checkout.SessionCreateParams.LineItem[] | undefined;
            locale?: "auto" | "de" | "en" | "fr" | "nl" | "es" | "it" | "pl" | "bg" | "cs" | "da" | "el" | "en-GB" | "es-419" | "et" | "fi" | "fr-CA" | "hu" | "id" | "ja" | "lt" | "lv" | "ms" | "mt" | "nb" | "pt" | "pt-BR" | "ro" | "ru" | "sk" | "sl" | "sv" | "tr" | "zh" | "zh-HK" | "zh-TW" | undefined;
            metadata?: Stripe.MetadataParam | undefined;
            mode?: "setup" | "payment" | "subscription" | undefined;
            payment_intent_data?: Stripe.Checkout.SessionCreateParams.PaymentIntentData | undefined;
            setup_intent_data?: Stripe.Checkout.SessionCreateParams.SetupIntentData | undefined;
            shipping_address_collection?: Stripe.Checkout.SessionCreateParams.ShippingAddressCollection | undefined;
            submit_type?: "auto" | "book" | "donate" | "pay" | undefined;
            subscription_data?: Stripe.Checkout.SessionCreateParams.SubscriptionData | undefined;
        } | undefined) => Promise<CreateIntentResponse>;
        execute: (options: ExecuteOptions) => Promise<ExecuteIntentResponse>;
        configure: (configuration: CheckoutConfiguration) => any;
    };
};
export default _default;
