"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const exceptions_1 = require("../exceptions");
exports.default = (Parent) => class {
    constructor() {
        // Create SDK Instance
        this.Instance = Parent.createInstance();
        this.create = (Items, custom) => new Promise((resolve, reject) => {
            var _a;
            // Get Items Output
            const Output = Items.get();
            // Create Payment Session
            this.Instance.checkout.sessions
                .create(Object.assign({ mode: "payment", payment_method_types: ((_a = this.Configuration) === null || _a === void 0 ? void 0 : _a.methods) || ["card"], success_url: this.Configuration.returnUrl, cancel_url: this.Configuration.cancelUrl, line_items: Output.items.map((item) => (Object.assign(Object.assign({}, item), { sku: undefined, price: undefined, amount: item.price * 100 }))) }, custom))
                .then((response) => {
                var _a, _b, _c, _d;
                return resolve({
                    method: Parent.getMethod(),
                    environment: ((_a = Parent.getConfiguration()) === null || _a === void 0 ? void 0 : _a.environment) || "Sandbox",
                    key: (_d = (_b = Parent.getConfiguration()) === null || _b === void 0 ? void 0 : _b.credentials[((_c = Parent.getConfiguration()) === null || _c === void 0 ? void 0 : _c.environment) || "Sandbox"]) === null || _d === void 0 ? void 0 : _d.PK,
                    response,
                });
            })
                .catch((error) => reject(new exceptions_1.GatewayException(error)));
        });
        this.execute = (options) => new Promise(async (resolve, reject) => {
            var _a, _b, _c;
            try {
                // Fetch Session
                const Session = await this.Instance.checkout.sessions.retrieve(options.paymentId);
                // Check Payment Intent
                if (Session.payment_intent) {
                    // Fetch Payment Intent
                    const PaymentIntent = await this.Instance.paymentIntents.retrieve(Session.payment_intent.toString());
                    // Check Payment Status
                    if (((_b = (_a = PaymentIntent === null || PaymentIntent === void 0 ? void 0 : PaymentIntent.charges) === null || _a === void 0 ? void 0 : _a.data[0]) === null || _b === void 0 ? void 0 : _b.status) === "succeeded")
                        resolve({
                            method: Parent.getMethod(),
                            environment: ((_c = Parent.getConfiguration()) === null || _c === void 0 ? void 0 : _c.environment) || "Sandbox",
                            response: {
                                session: Session,
                                paymentIntent: PaymentIntent,
                            },
                        });
                    else
                        throw new Error(`Payment has been failed!`);
                }
                else
                    throw new Error(`Payment Intent has not been found or invalid!`);
            }
            catch (error) {
                reject(new exceptions_1.GatewayException(error));
            }
        });
        this.configure = (configuration) => {
            // Validate Configuration
            if (!configuration.returnUrl ||
                typeof configuration.returnUrl !== "string")
                throw new exceptions_1.GatewayException(`Please provide a valid Return URL!`);
            if (!configuration.cancelUrl ||
                typeof configuration.cancelUrl !== "string")
                throw new exceptions_1.GatewayException(`Please provide a valid Cancel URL!`);
            // Save Configuration
            this.Configuration = configuration;
            return this;
        };
    }
};
